diff --git a/CMake/GenerateDCMTKConfigure.cmake b/CMake/GenerateDCMTKConfigure.cmake
index fb743c3..b0450bc 100644
--- a/CMake/GenerateDCMTKConfigure.cmake
+++ b/CMake/GenerateDCMTKConfigure.cmake
@@ -106,6 +106,10 @@ INCLUDE(${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)
 INCLUDE(${CMAKE_ROOT}/Modules/CheckLibraryExists.cmake)
 INCLUDE(${DCMTK_CMAKE_INCLUDE}CMake/CheckFunctionWithHeaderExists.cmake)
 
+CHECK_SYMBOL_EXISTS(__FUNCTION__        "" HAVE___FUNCTION___MACRO)
+CHECK_SYMBOL_EXISTS(__PRETTY_FUNCTION__ "" HAVE___PRETTY_FUNCTION___MACRO)
+CHECK_SYMBOL_EXISTS(__func__            "" HAVE___func___MACRO)
+
 # For Windows, hardcode these values to avoid long search times
 IF(WIN32 AND NOT CYGWIN)
   CHECK_INCLUDE_FILE_CXX("windows.h" HAVE_WINDOWS_H)
@@ -161,7 +165,9 @@ ENDIF(WIN32 AND NOT CYGWIN)
   CHECK_INCLUDE_FILE_CXX("sys/param.h" HAVE_SYS_PARAM_H)
   CHECK_INCLUDE_FILE_CXX("sys/resource.h" HAVE_SYS_RESOURCE_H)
   CHECK_INCLUDE_FILE_CXX("sys/select.h" HAVE_SYS_SELECT_H)
+  CHECK_INCLUDE_FILE_CXX("sys/syscall.h" HAVE_SYS_SYSCALL_H)
   CHECK_INCLUDE_FILE_CXX("sys/time.h" HAVE_SYS_TIME_H)
+  CHECK_INCLUDE_FILE_CXX("sys/timeb.h" HAVE_SYS_TIMEB_H)
   CHECK_INCLUDE_FILE_CXX("sys/types.h" HAVE_SYS_TYPES_H)
   CHECK_INCLUDE_FILE_CXX("sys/utime.h" HAVE_SYS_UTIME_H)
   CHECK_INCLUDE_FILE_CXX("sys/utsname.h" HAVE_SYS_UTSNAME_H)
@@ -173,6 +179,7 @@ ENDIF(WIN32 AND NOT CYGWIN)
   CHECK_INCLUDE_FILE_CXX("unistd.h" HAVE_UNISTD_H)
   CHECK_INCLUDE_FILE_CXX("unix.h" HAVE_UNIX_H)
   CHECK_INCLUDE_FILE_CXX("utime.h" HAVE_UTIME_H)
+  CHECK_INCLUDE_FILE_CXX("wchar.h" HAVE_WCHAR_H)
   CHECK_INCLUDE_FILE_CXX("wctype.h" HAVE_WCTYPE_H)
   CHECK_INCLUDE_FILE_CXX("alloca.h" HAVE_ALLOCA_H)
   CHECK_INCLUDE_FILE_CXX("arpa/inet.h" HAVE_ARPA_INET_H)
@@ -256,6 +263,8 @@ ENDIF(WIN32 AND NOT CYGWIN)
   CHECK_FUNCTION_EXISTS(lockf HAVE_LOCKF)
   CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
   CHECK_FUNCTION_EXISTS(malloc_debug HAVE_MALLOC_DEBUG)
+  CHECK_FUNCTION_EXISTS(mbstowcs HAVE_MBSTOWCS)
+  CHECK_FUNCTION_EXISTS(wcstombs HAVE_WCSTOMBS)
   CHECK_FUNCTION_EXISTS(memcmp HAVE_MEMCMP)
   CHECK_FUNCTION_EXISTS(memcpy HAVE_MEMCPY)
   CHECK_FUNCTION_EXISTS(memmove HAVE_MEMMOVE)
@@ -281,11 +290,15 @@ ENDIF(WIN32 AND NOT CYGWIN)
   CHECK_FUNCTION_EXISTS(tmpnam HAVE_TMPNAM)
   CHECK_FUNCTION_EXISTS(uname HAVE_UNAME)
   CHECK_FUNCTION_EXISTS(usleep HAVE_USLEEP)
+  CHECK_FUNCTION_EXISTS(_vsnprintf_s HAVE__VSNPRINTF_S)
+  CHECK_FUNCTION_EXISTS(vfprintf_s HAVE_VFPRINTF_S)
   CHECK_FUNCTION_EXISTS(vprintf HAVE_VPRINTF)
   CHECK_FUNCTION_EXISTS(vsnprintf HAVE_VSNPRINTF)
+  CHECK_FUNCTION_EXISTS(vsprintf_s HAVE_VSPRINTF_S)
   CHECK_FUNCTION_EXISTS(wait3 HAVE_WAIT3)
   CHECK_FUNCTION_EXISTS(waitpid HAVE_WAITPID)
   CHECK_FUNCTION_EXISTS(_findfirst HAVE__FINDFIRST)
+  CHECK_FUNCTION_EXISTS(nanosleep HAVE_NANOSLEEP)
 
   SET(HEADERS)
 
@@ -426,6 +439,7 @@ ENDIF(WIN32 AND NOT CYGWIN)
   CHECK_FUNCTIONWITHHEADER_EXISTS("__sync_sub_and_fetch((int*)0,0)" "${HEADERS}" HAVE_SYNC_SUB_AND_FETCH)
   CHECK_FUNCTIONWITHHEADER_EXISTS("InterlockedIncrement((long*)0)" "${HEADERS}" HAVE_INTERLOCKED_INCREMENT)
   CHECK_FUNCTIONWITHHEADER_EXISTS("InterlockedDecrement((long*)0)" "${HEADERS}" HAVE_INTERLOCKED_DECREMENT)
+  CHECK_FUNCTIONWITHHEADER_EXISTS(nanosleep "${HEADERS}" HAVE_PROTOTYPE_NANOSLEEP)
 
   # TODO: Uncommented because it seems not to make sense. Remove if there are no complaints.
   #CHECK_LIBRARY_EXISTS(iostream "" "" HAVE_LIBIOSTREAM)
diff --git a/CMake/osconfig.h.in b/CMake/osconfig.h.in
index 711b09a..54101da 100755
--- a/CMake/osconfig.h.in
+++ b/CMake/osconfig.h.in
@@ -332,6 +332,9 @@
 /* Define to 1 if you have the <math.h> header file. */
 #cmakedefine HAVE_MATH_H @HAVE_MATH_H@
 
+/* Define to 1 if you have the `mbstowcs' function. */
+#cmakedefine HAVE_MBSTOWCS @HAVE_MBSTOWCS@
+
 /* Define to 1 if you have the `memcmp' function. */
 #cmakedefine HAVE_MEMCMP @HAVE_MEMCMP@
 
@@ -485,6 +488,9 @@
 /* Define if your system has a prototype for _stricmp in string.h */
 #cmakedefine HAVE_PROTOTYPE__STRICMP @HAVE_PROTOTYPE__STRICMP@
 
+/* Define if your system has a prototype for nanosleep in time.h */
+#cmakedefine HAVE_PROTOTYPE_NANOSLEEP @HAVE_PROTOTYPE_NANOSLEEP@
+
 /* Define to 1 if you have the <pthread.h> header file. */
 #cmakedefine HAVE_PTHREAD_H @HAVE_PTHREAD_H@
 
@@ -660,6 +666,12 @@
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #cmakedefine HAVE_SYS_STAT_H @HAVE_SYS_STAT_H@
 
+/* Define to 1 if you have the <sys/syscall.h> header file. */
+#cmakedefine HAVE_SYS_SYSCALL_H @HAVE_SYS_SYSCALL_H@
+
+/* Define to 1 if you have the <sys/timeb.h> header file. */
+#cmakedefine HAVE_SYS_TIMEB_H @HAVE_SYS_TIMEB_H@
+
 /* Define to 1 if you have the <sys/time.h> header file. */
 #cmakedefine HAVE_SYS_TIME_H @HAVE_SYS_TIME_H@
 
@@ -708,21 +720,48 @@
 /* Define to 1 if you have the `vprintf' function. */
 #cmakedefine HAVE_VPRINTF @HAVE_VPRINTF@
 
+/* Define to 1 if you have the `_vsnprintf_s' function. */
+#cmakedefine HAVE__VSNPRINTF_S @HAVE__VSNPRINTF_S@
+
+/* Define to 1 if you have the `vfprintf_s' function. */
+#cmakedefine HAVE_VFPRINTF_S @HAVE_VFPRINTF_S@
+
 /* Define to 1 if you have the `vsnprintf' function. */
 #cmakedefine HAVE_VSNPRINTF @HAVE_VSNPRINTF@
 
+/* Define to 1 if you have the `vsprintf_s' function. */
+#cmakedefine HAVE_VSPRINTF_S @HAVE_VSPRINTF_S@
+
 /* Define to 1 if you have the `wait3' function. */
 #cmakedefine HAVE_WAIT3 @HAVE_WAIT3@
 
 /* Define to 1 if you have the `waitpid' function. */
 #cmakedefine HAVE_WAITPID @HAVE_WAITPID@
 
+/* Define to 1 if you have the <wchar.h> header file. */
+#cmakedefine HAVE_WCHAR_H @HAVE_WCHAR_H@
+
+/* Define to 1 if you have the `wcstombs' function. */
+#cmakedefine HAVE_WCSTOMBS @HAVE_WCSTOMBS@
+
 /* Define to 1 if you have the <wctype.h> header file. */
 #cmakedefine HAVE_WCTYPE_H @HAVE_WCTYPE_H@
 
 /* Define to 1 if you have the `_findfirst' function. */
 #cmakedefine HAVE__FINDFIRST @HAVE__FINDFIRST@
 
+/* Define to 1 if the compiler supports __FUNCTION__. */
+#cmakedefine HAVE___FUNCTION___MACRO @HAVE___FUNCTION___MACRO@
+
+/* Define to 1 if the compiler supports __PRETTY_FUNCTION__. */
+#cmakedefine HAVE___PRETTY_FUNCTION___MACRO @HAVE___PRETTY_FUNCTION___MACRO@
+
+/* Define to 1 if the compiler supports __func__. */
+#cmakedefine HAVE___func___MACRO @HAVE___func___MACRO@
+
+/* Define to 1 if you have the `nanosleep' function. */
+#cmakedefine HAVE_NANOSLEEP @HAVE_NANOSLEEP@
+
 /* Define if <math.h> fails if included extern "C" */
 #define INCLUDE_MATH_H_AS_CXX 1
 
diff --git a/config/configure.in b/config/configure.in
index 1b74a2a..913af6c 100644
--- a/config/configure.in
+++ b/config/configure.in
@@ -248,6 +248,7 @@ AC_CHECK_FUNCS(sleep fork)
 AC_CHECK_FUNCS(_findfirst)
 AC_CHECK_FUNCS(strlcpy strlcat)
 AC_CHECK_FUNCS(vsnprintf)
+AC_CHECK_FUNCS(mbstowcs wcstombs)
 AC_FUNC_FSEEKO
 
 
@@ -268,7 +269,7 @@ AC_CACHE_CHECK([for socklen_t], ac_cv_type_socklen_t,
   fi
 ])
 
-AC_CHECK_FUNCS(ftime gmtime_r localtime_r lstat)
+AC_CHECK_FUNCS(ftime gmtime_r localtime_r lstat nanosleep fcntl)
 AC_CHECK_FUNCS(htons htonl ntohs ntohl)
 AC_CHECK_HEADERS(netinet/in.h)
 AC_CHECK_HEADERS(syslog.h)
@@ -509,7 +510,9 @@ AC_CHECK_HEADERS(sys/resource.h)
 AC_CHECK_HEADERS(sys/select.h)
 AC_CHECK_HEADERS(sys/socket.h)
 AC_CHECK_HEADERS(sys/stat.h)
+AC_CHECK_HEADERS(sys/syscall.h)
 AC_CHECK_HEADERS(sys/time.h)
+AC_CHECK_HEADERS(sys/timeb.h)
 AC_CHECK_HEADERS(sys/types.h)
 AC_CHECK_HEADERS(sys/utime.h)
 AC_CHECK_HEADERS(sys/utsname.h)
@@ -518,6 +521,7 @@ AC_CHECK_HEADERS(time.h)
 AC_CHECK_HEADERS(unistd.h)
 AC_CHECK_HEADERS(unix.h)
 AC_CHECK_HEADERS(utime.h)
+AC_CHECK_HEADERS(wchar.h)
 AC_CHECK_HEADERS(wctype.h)
 
 if test $ac_cv_header_libc_h = yes ; then
@@ -733,6 +737,9 @@ AC_CHECK_SIZEOF(float)
 AC_CHECK_SIZEOF(double)
 AC_CHECK_SIZEOF(void *)
 AC_STRUCT_TM
+AC_MY_SYMBOL_EXISTS([__FUNCTION__])
+AC_MY_SYMBOL_EXISTS([__PRETTY_FUNCTION__])
+AC_MY_SYMBOL_EXISTS([__func__])
 
 dnl -------------------------------------------------------
 dnl Checks for prototypes
diff --git a/config/include/dcmtk/config/osconfig.h.in b/config/include/dcmtk/config/osconfig.h.in
index c1cbf2c..6bf9a8f 100644
--- a/config/include/dcmtk/config/osconfig.h.in
+++ b/config/include/dcmtk/config/osconfig.h.in
@@ -150,6 +150,9 @@
    syntax */
 #undef HAVE_EXPLICIT_TEMPLATE_SPECIALIZATION
 
+/* Define to 1 if you have the `fcntl' function. */
+#undef HAVE_FCNTL
+
 /* Define to 1 if you have the <fcntl.h> header file. */
 #undef HAVE_FCNTL_H
 
@@ -354,6 +357,9 @@
 /* Define to 1 if you have the <math.h> header file. */
 #undef HAVE_MATH_H
 
+/* Define to 1 if you have the `mbstowcs' function. */
+#undef HAVE_MBSTOWCS
+
 /* Define to 1 if you have the `memcmp' function. */
 #undef HAVE_MEMCMP
 
@@ -375,6 +381,9 @@
 /* Define to 1 if you have the `mktemp' function. */
 #undef HAVE_MKTEMP
 
+/* Define to 1 if you have the `nanosleep' function. */
+#undef HAVE_NANOSLEEP
+
 /* Define to 1 if you have the <ndir.h> header file, and it defines `DIR'. */
 #undef HAVE_NDIR_H
 
@@ -739,6 +748,12 @@ typedef unsigned short ushort;
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #undef HAVE_SYS_STAT_H
 
+/* Define to 1 if you have the <sys/syscall.h> header file. */
+#undef HAVE_SYS_SYSCALL_H
+
+/* Define to 1 if you have the <sys/timeb.h> header file. */
+#undef HAVE_SYS_TIMEB_H
+
 /* Define to 1 if you have the <sys/time.h> header file. */
 #undef HAVE_SYS_TIME_H
 
@@ -806,12 +821,27 @@ typedef unsigned short ushort;
 /* Define to 1 if you have the `waitpid' function. */
 #undef HAVE_WAITPID
 
+/* Define to 1 if you have the <wchar.h> header file. */
+#undef HAVE_WCHAR_H
+
+/* Define to 1 if you have the `wcstombs' function. */
+#undef HAVE_WCSTOMBS
+
 /* Define to 1 if you have the <wctype.h> header file. */
 #undef HAVE_WCTYPE_H
 
 /* Define to 1 if you have the `_findfirst' function. */
 #undef HAVE__FINDFIRST
 
+/* Define if the compiler supports __FUNCTION__. */
+#undef HAVE___FUNCTION___MACRO
+
+/* Define if the compiler supports __PRETTY_FUNCTION__. */
+#undef HAVE___PRETTY_FUNCTION___MACRO
+
+/* Define if the compiler supports __func__. */
+#undef HAVE___func___MACRO
+
 /* Define if libc.h should be treated as a C++ header */
 #undef INCLUDE_LIBC_H_AS_CXX
 
